#ifndef FWIINTEGRALOPERATORPRECONDITIONER_H_
#define FWIINTEGRALOPERATORPRECONDITIONER_H_

#include <memory>

#include "DGVAcousticAssembleCombined.hpp"
#include "FWITimeSolver.hpp"
#include "Preconditioner.hpp"
#include "VAcousticMatFromVec.hpp"

class AAOIntegralPrecon : public Preconditioner {
    const Vector &WaveVec;
    std::shared_ptr<DGVAcousticAssembleCombined> assembleFWD;
    std::shared_ptr<DGVAcousticAssembleCombined> assembleBWD;
    const EleCacheType &eleCache;
    Matrix Mass;
    std::unique_ptr<LinearSolver> solvIM;
    double t0{};
    double dt{};
    double T{};

  public:
    AAOIntegralPrecon(const Vector &WaveVec_, ABCHandlerAAO *abch_,
                      const EleCacheType &eleCache, const Vector &MatVec, const FWIVAcousticInversionProb &prob, double t0,
                    double T, double dt);

  ~AAOIntegralPrecon() override = default;

    void Construct(const Matrix &) override {}

    void Destruct() override {}

    void multiply2(Vectors &u, const Vectors &b, bool fwd) const;

    void multiply(Vectors &u, const Vectors &b) const override;

    void multiply_transpose(Vectors &u, const Vectors &b) const override;

    std::string Name() const override { return "AAOPrecon"; }
};

#endif
