//
// Created by cr on 14.10.21.
//

#include "FWILinearizedIntegralOperator.hpp"

#include <utility>

void FWILinearizedIntegralOperator::Evaluate(const Vector &materialDirection,
                                             Vectors &LinearizedEvaluation) const {
  Vector tmp(0.0, LinearizedEvaluation[0]);
  Vector tmp2(0.0, LinearizedEvaluation[0]);
  for (int timeStep = 0; timeStep < LinearizedEvaluation.size(); ++timeStep) {
    tmp = WaveFieldPoint[timeStep];
    linAssembler.MPrimeMatVec(materialDirection, VecsInte.integrateOneStepAndGetVector(), tmp);
    LinearizedEvaluation[timeStep] = tmp;
  }
  VecsInte.Reset();
}

FWILinearizedIntegralOperator::FWILinearizedIntegralOperator(
    std::shared_ptr<FWIVAcousticInversionProb> problem_fwd_,
    const std::unordered_map<Point, DGAcousticElement *> &eleCache_,
    const Vector &materialPoint_, const Vectors &WaveFieldPoint_, double dt,
    int rkorder)
    :
        linAssembler(std::move(problem_fwd_), eleCache_, materialPoint_),
        VecsInte(WaveFieldPoint_, dt, rkorder),
        WaveFieldPoint(WaveFieldPoint_){
}
