//
// Created by cr on 24.08.22.
//

#include "FWIRhsAssemblerAdjoint.hpp"

DGVAcousticRHSAssemblerAdjoint::DGVAcousticRHSAssemblerAdjoint(const FWIObservationOperatorDGTS &Obs) :
         Obs(Obs) {
    Config::Get("rkorder", rkorder);
    if (!(rkorder == -2 || rkorder == -302 || rkorder == -1002 || rkorder == 1002 || rkorder == -2002)) {
        Exit("Debug this method for your rkorder"); //rkorder = -102 does NOT(!!!) work
    }
}

void DGVAcousticRHSAssemblerAdjoint::Initialize(Vector &u) const {}

void DGVAcousticRHSAssemblerAdjoint::SetSeis(const DGSeismogram *s) {
    DGVAcousticRHSAssemblerAdjoint::Seis = s;
    CurrentStep = static_cast<int>
        (std::nearbyint(Obs.GetSpaceOp().GetSpecification().GetEndTime()
                        /
                       Obs.GetSpaceOp().GetSpecification().GetTimeDelta()));
}

void DGVAcousticRHSAssemblerAdjoint::RHS(double t_, Vector &b) const {
    b.Clear();
    for (const auto &receiver: Obs.GetSpaceOp().GetSpaceSupport()) {
      FWIState meas(0.0, 1);
      if (rkorder == -302) {
        meas[0] = FirstStep ? Seis->GetTimeSeries(receiver.first)[CurrentStep]
                            : Seis->GetTimeSeries(receiver.first)[CurrentStep - 1];
      } else {
        meas[0] = 0.5 * (Seis->GetTimeSeries(receiver.first)[CurrentStep] +
                         Seis->GetTimeSeries(receiver.first)[CurrentStep - 1]);
      }
      Obs.GetMask().adjoint(meas);
        Obs.GetSpaceOp().SetSpaceValue(meas, receiver.first, receiver.second, b);
    }
    if (rkorder == -302) {
      if (FirstStep) FirstStep = false;
      else {
        FirstStep = true;
        CurrentStep--;
      }
    } else {
      CurrentStep--;
    }
}
