//
// Created by cr on 24.08.22.
//

#ifndef FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP
#define FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP


#include "DGVAcousticRHSAssembler.hpp"
#include "Observation/FWIObservationOperatorDGTS.hpp"
// this class assumes the same dt for the seismogram as for the measurement
class DGVAcousticRHSAssemblerAdjoint : public DGVAcousticRHSAssembler {
    const DGSeismogram *Seis{};
    const FWIObservationOperatorDGTS &Obs;
    mutable int CurrentStep{};
    mutable bool FirstStep = true;
    int rkorder = -2;

  public:
    explicit DGVAcousticRHSAssemblerAdjoint(const FWIObservationOperatorDGTS &Obs);

    void Initialize(Vector &u) const override;

    void SetSeis(const DGSeismogram *s);

    void RHS(double t_, Vector &b) const override;
};


#endif //FWI_DGVACOUSTICRHSASSEMBLERADJOINT_HPP
