//
// Created by cr on 26/03/23.
//
#include "FWIProblemWrapper.hpp"
double FWIProblemWrapperVA2::Kappa(const Cell &C, const Point &x) const {
  double kappa = 0;
  for (int i = 0; i <= numL; ++i) {
    kappa += Kappa_i(C, x, i);
  }
  return kappa;
}

double FWIProblemWrapperVA2::Kappa_i(const Cell &C, const Point &x, int i) const {
  return MatVec->Kappa_i(C,x, i);
}

double FWIProblemWrapperVA2::Tau_i(const Cell &c, const Point &x, int i) const {
  return 1.0/MatVec->invTau_i(c,x,i);
}

double FWIProblemWrapperVA2::Rho(const Cell &C, const Point &x) const {
  return MatVec->Rho(C,x);
}

double FWIProblemWrapper::Kappa(const Cell &C, const Point &x) const {
  double kappa = 0;
  for (int i = 0; i <= numL; ++i) {
    kappa += Kappa_i(C, x, i);
  }
  return kappa;
}

double FWIProblemWrapper::Kappa_i(const Cell &C, const Point &x, int i) const {
  return (*MatVec)(C(), 1 + i);
}

double FWIProblemWrapper::Tau_i(const Cell &c, const Point &x, int i) const {
  return fwd->Tau_i(c, x, i);
}

double FWIProblemWrapper::Rho(const Cell &C, const Point &x) const {
  return (*MatVec)(C(), 0);
}