#ifndef FWIMPPHELPERS_H
#define FWIMPPHELPERS_H

#include "m++.hpp"
//#include "ForwardModels/FWIForwardModel.hpp"
#include <iomanip>
#include "Point.hpp"
#include "RVector.hpp"
#include "Vector.hpp"
// ------------------------------------------------------------
// Subject to change

typedef RVector FWIState;


double zKTauPositive(int numL, double alpha, double rhoK, double vK, double taupK);

double zKPrimeTauPositive(int numL, double alpha, double rhoK, double vK, double taupK, double rhoDK, double vDK,
                          double taupDK);

double zKTau(int numL, double alpha, double rhoK, double vK, double taupK);

double zKPrimeTau(int numL, double alpha, double rhoK, double vK,
                  double taupK, double rhoDK, double vDK, double taupDK);

std::vector<Point> PointsOnLine(vector<Point> &waypoints,
                                vector<int> &nrOfPointsOnLine);

inline void ReadJSONToVec(const std::string& fn,Vector& M,int param){
  json j;
  std::ifstream ifs(fn + ".json");
  if (!ifs.good()) Exit("Failed to open file" + fn);
  nlohmann::json CellData = nlohmann::json::parse(ifs);
  std::vector<Point> CellCenters;
  std::vector<double> CellDataDouble;
    for (const auto &p: CellData.at("CellCenters")) {
    Point  pt(std::vector<double>{p[0],p[1]});
    CellCenters.push_back(pt);
  }
  for (const auto &d: CellData.at("Data")) {
    CellDataDouble.push_back(d);
  }
  for (int i = 0; i < CellCenters.size(); ++i) {
    Point  pt = CellCenters[i];
    if ( M.find_cell(pt) != M.cells_end()){
      M(pt,param) = CellDataDouble[i];
    }
  }
}
#endif
