//
// Created by cr on 14.10.21.
//

#ifndef FWI_GRAMIANBLOCKINVERSE_HPP
#define FWI_GRAMIANBLOCKINVERSE_HPP

#include "DGAcousticElement.hpp"
#include "DGElement.hpp"
#include "lib1_math/basicalgebra/SparseRMatrix.hpp"
#include "lib4_fem/algebra/Matrix.hpp"

RMatrix getRMatrixFromCell(const Matrix &A, const Cell &C);

class GramianBlockInverse {
    const std::unordered_map<Point, DGAcousticElement *> &eleCache;

    void productOneCellScalarProductInverse(const Vector &u, const DGAcousticElement &elem, Vector &b) const;

    void productOneCellSparse(const Vector &u, const SparseRMatrix &SpSm, int Row, Vector &b) const;

    std::shared_ptr<Matrix> scalarProductMatrix = nullptr;
    std::unordered_map<int, SparseRMatrix> ScalarMInverse;

  public:
    GramianBlockInverse(const Vector& WaveVec,
                        const std::unordered_map<Point, DGAcousticElement *> &eleCache);

  void ScalarProductInverse(Vectors &b) const {
    for (size_t i = 0; i < b.size(); ++i) {
      ScalarProductInverse(b[i]);
    }
  }
  const Matrix& ScalarProductMatrix(){
    return *scalarProductMatrix;
  }
  void ScalarProductInverse(Vector &b) const;

  const SparseRMatrix &at(double a) {
    return ScalarMInverse.at(a);
  }

};


#endif //FWI_GRAMIANBLOCKINVERSE_HPP
