//
// Created by cr on 01/02/24.
//

#ifndef FWI_RECONSTRUCTIONCONTAINER_HPP
#define FWI_RECONSTRUCTIONCONTAINER_HPP

#include "m++.hpp"
class ReconstructionContainer {
public:
  std::vector<unsigned int> ReconVec;
  bool Rho = false;
  bool Kappa0 = false;
  bool Vp = false;
  bool Taup = false;
  bool KappaL = false;
  ReconstructionContainer() = delete;
  explicit ReconstructionContainer(const FWIVAcousticInversionProb& prob){
    const std::string &parametrization = prob.getParametrization();

    Config::Get("FWIReconstructRho", Rho);
    Config::Get("FWIReconstructKappa0", Kappa0);
    Config::Get("FWIReconstructV_P", Vp);
    Config::Get("FWIReconstructTauP", Taup);
    if (!(Rho || Kappa0 || Vp || Taup)){
      THROW("No parameters to be reconstructed!!");
    }
    if (Rho)
      ReconVec.push_back(0);
    if (parametrization == "native") {
      if (Kappa0)
        ReconVec.push_back(1);
    } else if (parametrization == "taup" || parametrization == "taup_positive") {
      if (Vp)
        ReconVec.push_back(1);
      if (prob.GetNumL() > 0 && Taup)
        ReconVec.push_back(2);
    }
  }
};
#endif  // FWI_RECONSTRUCTIONCONTAINER_HPP
