//
// Created by cr on 10.11.22.
//

#ifndef FWI_FWIOBSERVATIONOPERATORDGTS_HPP
#define FWI_FWIOBSERVATIONOPERATORDGTS_HPP

#include <memory>
#include <unordered_set>
#include <utility>

#include "DGSeismogram.hpp"
#include "FWIObservationOperatorSpaceDGTS.hpp"
#include "FWIObservationOperatorTimeDGTS.hpp"
#include "Helper/FWIHelpers.hpp"
#include "Helper/FWIMppHelpers.hpp"
#include "MeasureMask.hpp"
#include "VectorField.hpp"
#include "lib6_app/seismogram/ObservationSpecification.hpp"

std::unique_ptr<MeasureMask> GetMeasureMask(int dim, int numL, int MeasureComp);


class FWIObservationOperatorDGTS {
    std::unique_ptr<FWIObservationOperatorTimeDGTS> timeOp = nullptr;

    std::unique_ptr<FWIObservationOperatorSpaceDGTS> spaceOp = nullptr;

    std::unique_ptr<MeasureMask> Mask = nullptr;

protected:
public:
    FWIObservationOperatorDGTS(std::unique_ptr<FWIObservationOperatorTimeDGTS> TimeOp_,
                               std::unique_ptr<FWIObservationOperatorSpaceDGTS> SpaceOp_,
                               std::unique_ptr<MeasureMask> Mask_) :
            timeOp(std::move(TimeOp_)), spaceOp(std::move(SpaceOp_)), Mask(std::move(Mask_)) {}

    ~FWIObservationOperatorDGTS() = default;

    void MeasureFullWave(const Vectors &U, DGSeismogram &s) const;

    void MeasureSingleWaveField(const Vector &U, DGSeismogram &s, int step) const;

    const FWIObservationOperatorSpaceDGTS &GetSpaceOp() const{ return *spaceOp; }

    const FWIObservationOperatorTimeDGTS &GetTimeOp() const {return *timeOp;}

    const MeasureMask &GetMask() const {return *Mask;}

};


#endif //FWI_FWIOBSERVATIONOPERATORDGTS_HPP
