//
// Created by cr on 25/01/24.
//

#ifndef FWI_FWIOBSERVATIONOPERATORTIMEDGTS_HPP
#define FWI_FWIOBSERVATIONOPERATORTIMEDGTS_HPP

#include <memory>
#include <unordered_set>
#include <utility>

#include "DGSeismogram.hpp"
#include "FWIObservationOperatorSpaceDGTS.hpp"
#include "Helper/FWIHelpers.hpp"
#include "Helper/FWIMppHelpers.hpp"
#include "MeasureMask.hpp"
#include "VectorField.hpp"
#include "lib6_app/seismogram/ObservationSpecification.hpp"

class FWIObservationOperatorTimeDGTS {
    std::shared_ptr<ObservationSpecification> spec;
public:
    FWIObservationOperatorTimeDGTS() = delete;

    explicit FWIObservationOperatorTimeDGTS(std::shared_ptr<ObservationSpecification> spec_) : spec(std::move(spec_)) {}

    virtual std::list<int> TimeSupport(int) const = 0;

    virtual double operator()(double t) const = 0;

    virtual ~FWIObservationOperatorTimeDGTS() = default;
};

class FWIObservationOperatorTimePointDGTS : public FWIObservationOperatorTimeDGTS {
public:
    FWIObservationOperatorTimePointDGTS() = delete;

    explicit FWIObservationOperatorTimePointDGTS(std::shared_ptr<ObservationSpecification> spec_)
            : FWIObservationOperatorTimeDGTS(std::move(spec_)) {}

    std::list<int> TimeSupport(int i) const override { return {i}; }

    double operator()(double t) const override {
        return 1.0;
    }


};

#endif //FWI_FWIOBSERVATIONOPERATORTIMEDGTS_HPP
