//
// Created by cr on 24.11.22.
//

#include "WaypointSources.hpp"

void WaypointSources::CheckOldOptions() {
    double SourceStartX = -infty;
    double SourceStartY = -infty;
    double SourceEndX = -infty;
    double SourceEndY = -infty;
    int shots = -1;
    Config::Get("shots", shots);
    Config::Get("SourceStartX", SourceStartX);
    Config::Get("SourceStartY", SourceStartY);
    Config::Get("SourceEndX", SourceEndX);
    Config::Get("SourceEndY", SourceEndY);
    if (SourceStartX != -infty || SourceStartY != -infty || SourceEndY != -infty || SourceEndY != -infty ||
        shots != -1) {
        THROW("Use new Interface with Waypoints")
    }
}

void WaypointSources::initialize(vector<Point>& waypoints,
                                 vector<int>& SourceCounts) {
    Config::Get("numberOfSourcesPerShot", numberOfSourcesPerShot);
    if (numberOfSourcesPerShot > 1) THROW("Implement this again!");
    int WaypointCount = waypoints.size();
    ReadWaypoints("FWISource", WaypointCount, waypoints, SourceCounts);
    auto PoL = PointsOnLine(waypoints, SourceCounts);
    int j = 0;
    for (const Point &P: PoL) {
        std::vector<Point> test{P};
        shotLocations.push_back(test);
    }
    mout << "SOURCE LOCATIONS: " << endl;
    int i = 0;
    for (auto p = shotLocations.begin(); p != shotLocations.end(); ++p, ++i) {
        mout << "  " << i << ": " << *p << endl;
//            if (i < 10) mout << " ";
//            if (((i + 1) % (*p)[0].SpaceDim()) == 0) mout
    }
}

WaypointSources::WaypointSources() {
    CheckOldOptions();
    std::vector<Point> waypoints;
    std::vector<int> SourceCounts;
  initialize(waypoints, SourceCounts);
}

WaypointSources::WaypointSources(std::vector<Point> waypoints,
                                 std::vector<int> SourceCounts) {
    CheckOldOptions();
    initialize(waypoints, SourceCounts);
}

