//
// Created by cr on 18.11.22.
//

#ifndef FWI_FWILINOPADJRED_HPP
#define FWI_FWILINOPADJRED_HPP

#include "Assembler/FWIRhsAssemblerAdjoint.hpp"
#include "DGVAcousticAssembleCombined.hpp"
#include "DGVAcousticMatrixAssembler.hpp"
#include "FWIAbstractInterfaceDGTSVA.hpp"
#include "FWIAdjointCalculator.hpp"
#include "Helper/ABCHandler.hpp"
#include "Helper/ReconstructionContainer.hpp"
#include "Observation/FWIObservationOperatorDGTS.hpp"
#include "Problems/FWIAcousticInversionProb.hpp"
#include "VAcousticMatFromVec.hpp"
#include "Vector.hpp"
class FWILinOpAdjRed {
    const std::shared_ptr<ABCHandler> &PMLH;
    std::shared_ptr<EleCacheType> eleCache;
    std::shared_ptr<DGVAcousticAssembleCombined> assemble;
    const Vectors &U_m;
    const Vector &MatVec;
    const TimeConf &TConf;
    std::unique_ptr<FWIAdjointCalculator> fwiAdjointCalculator = nullptr;
    std::unique_ptr<TimeIntegrator> timeIntegrator = nullptr;
protected:
  std::shared_ptr<DGVAcousticRHSAssemblerAdjoint> AdjointRHS;
  void calculateAdjointIntern(Vector &AdjointVector, Vectors *LambdaFull);
public:
    FWILinOpAdjRed(const Vectors &U_m_, const Vector &MatVec_, const FWIObservationOperatorDGTS &Obs,
                   const std::shared_ptr<FWIVAcousticInversionProb> &prob_,
                   const std::shared_ptr<ABCHandler> &PMLH_, const TimeConf &TConf_,
                   const ReconstructionContainer &recon,
                 std::shared_ptr<EleCacheType> eleCache_);

    virtual void CalculateAdjoint(const DGSeismogram &s, Vector &AdjointVector, Vectors *LambdaFull){
      AdjointRHS->SetSeis(&s);
      calculateAdjointIntern(AdjointVector,LambdaFull);
    }
    void CalculateL2AdjointStep(const Vector &LambdaStep, Vector &AdjointVector, int step);
};


#endif //FWI_FWILINOPADJRED_HPP
