//
// Created by cr on 13/02/23.
//

#ifndef FWI_FWITESTSTF_HPP
#define FWI_FWITESTSTF_HPP

#include <string>
#include <map>

using ConfigMap = std::map<std::string, std::string>;
const ConfigMap FWTTestSTFConfigMap{
    {"ConfigVerbose",                  "0"},
    {"ForwardSolver",                  " VADGTS"},
    {"Distribution",                   " RCB"},
    {"Model",                          " FWIInverse_DGTS"},
    {"Mesh",                           " square2000x2000_20x20"},
    {"Problem",                        " VAcousticWaveC2Benchmark"},
    {"useTaper",                       "1"},
    {"taperRadiusSource",              "0"},
    {"taperRadiusReceiver",            "0"},
    {"taperExponent",                  "-0.1"},
    {"taperIgnoreReceiverCells",       "1"},
    {"taperIgnoreSourceCells",         "1"},
    {"Monoparam",                      " "},
    {"ReconstructionType",             " Classical"},
    {"ReceiverWaypoints",           " 2"},
    {"ReceiverWaypoint0",           " 1350.0, 370.0"},
    {"ReceiverWaypoint1",           " 1350.0, 1630.0"},
    {"ReceiverCount0",              " 32"},
    {"UseSparseMatrix",                "1"},
    {"Qfactor",                        "100"},
    {"SignalName",                     "Sin"},
    {"FrequencyFiltering", "1"},
    {"FrequencyLevels", "15"},
    {"SignalCutoff",                   "0.8"},
    {"SignalFreq",                     "25"},
    {"numL",                           " 0"},
    {"FWISourceWaypoints",             "2"},
    {"FWISourceWaypoint0",             "600,370"},
    {"FWISourceWaypoint1",             "600,1620"},
    {"FWISourceCount0",                "3"},
    {"measurement_space",              " point"},
    {"measurement_time",               " point"},
    {"MeasureComp",                    " 0"},
    {"source_component",               " 2"},
    {"perturbation_comp",              " 2"},
    {"dampingFlux",                    " 1"},
    {"allowPlotting_M",                "1"},
    {"allowPlotting_WF",               "0"},
    {"plotfactor",                     " 10"},
    {"parametrization",                " taup_positive"},
    {"T",             "0.6"},
    {"dt",            " 0.0005"},
    {"deg",           " 1"},
    {"plevel",        "2"},
    {"level",         "2"},
    {"TimeVerbose",   " 1"},
    {"plot_tStep",    " -1"},
    {"rkorder",       " -2"},
    {"Kmax",          "150"},
    {"Keps",          " 1e-07"},
    {"Overlap",       " dG1"},
    {"debugAdjoint",  " 0"},
    {"debugFrechet",  " 1"},
    {"source_factor", " 24257425742.5742"},
    {"LinearSolver",  " LS"},
    {"LinearVerbose", " -1"},
    {"LinearSteps", "100"},
    {"LinearNthIterOutput",    " 1"},
    {"LinearEpsilon",          " 1e-12"},
    {"LinearReduction",        " 0.0001"},
    {"FWINonlinearSolver",     " FWI_CGREGINN"},
    {"FWI_DebugPlottingLevel", " 1"},
    {"FWIReconstructRho",      " 1"},
    {"FWIReconstructV_P",      " 1"},
    {"FWIReconstructTauP",     " 1"},
    {"CGREGINNCanonic_Steps",  "0"},
    {"PaddingPML","1"},
    {"PMLPaddingLength", "200.0, 200.0 ,200, 200.00"},
    {"PMLBnds", "1, 1,1, 1"},
    {"PMLDistFactor" , "0.8"},
    {"SourceInversion", "1"},
    {"SourceInversion", "1"},
//    {"SourceInversionKappa", "0.8"},
    {"SourceInversionEps", "0.005"},
    {"SaveObservedSeismogram","1"},
    {"seismopath", "TestObs"},
    {"ConfigVerbose", "2"},
};



#endif //FWI_FWITESTSTF_HPP
